package perfSONAR::Echo;

#DEBUG
use Data::Dumper;
#/DEBUG

use strict;
use warnings;

use perfSONAR qw(print_log %services);

our $log = undef;

our %services = ();

my $echo_et = "http://schemas.perfsonar.net/tools/admin/echo/2.0";
my $selftest_et = "http://schemas.perfsonar.net/tools/admin/selftest/1.0";
my $response_et = "http://schemas.perfsonar.net/tools/admin/selftest/";

my $returnstring = "I'm still alive and happy to talk to you!";

sub handle_echo_request{
#sub start_action {
  my $msg = shift;
  my $service = shift;

  print Dumper($msg->{"metadataIDs"});

  foreach my $key (keys %{$msg->{"metadataIDs"}}){
    my $et = $msg->{"metadataIDs"}{$key}{"eventType"};
    if ($et =~ /$echo_et/){
      #echo request
      print_log("info", "Reply to EchoRequest ping");
      $msg->return_result_code("success.echo", "$returnstring", "$key");
    }
    elsif ($et =~ /$selftest_et/){

      #my %refs = $services{$service}->{handler}->selftest();
      my $refs = $services{$service}->{handler}->selftest();
      if (!$refs){
        print_log("notice", "error.echo: Action not supported: $et.");
        $msg->return_result_code("error.echo", "Action not supported: $et.", $key);
        return $msg;
      }
      foreach my $name (keys %{$refs}){
        my $ref = $refs->{$name};
        my ($message, $status) = $services{$service}->{handler}->$ref;
        print_log("notice", "$message $service");
        $msg->return_result_code("$response_et$service/$name/$status/1.0", "$message", "$key", "$name");
      }

    }
    else { #some different eventtype, return error
      $msg->return_result_code("error.echo", "Unknown eventType: $et", $key);
      return $msg;
    }
    #return success message
    return $msg;
  }

}
1;
